import teem.nrrd as nrrd

# BEWARE: This does not work well for compression at all.
##############################################################################

def sample_half(nin):
    sample_down = nrrd.NrrdResampleContext()
    sample_down.set_nrrd(nin)
    sample_down.set_default_center(nrrd.Center.Cell)
    for i in xrange(nin.dim):
        sample_down.set_kernel(i, nrrd.Kernel.Tent, [1.0])
        sample_down.set_samples(i, nin.axis[i].size / 2)
    sample_down.set_type_out(nin.type)
    down = sample_down.execute()

    sample_up = nrrd.NrrdResampleContext()
    sample_up.set_nrrd(down)
    sample_up.set_default_center(nrrd.Center.Cell)
    for i in xrange(nin.dim):
        sample_up.set_kernel(i, nrrd.Kernel.Tent, [1.0])
        sample_up.set_samples(i, nin.axis[i].size)
    sample_up.set_type_out(nin.type)
    up = sample_up.execute()

    residual = nin - up
    return (down, up, residual)

def make_pyramid(nin, levels):
    residuals = []
    current = nin
    for i in xrange(levels):
        (down, up, residual) = sample_half(current)
        residuals.append(residual)
        current = down
    return (current, residuals)

def reconstruct_from_pyramid(base, residuals):
    sample_up = nrrd.NrrdResampleContext()
    current = base
    for residual in reversed(residuals):
        sample_up.set_nrrd(current)
        sample_up.set_default_center(nrrd.Center.Cell)
        print "Upsampling to",
        for i in xrange(residual.dim):
            sample_up.set_kernel(i, nrrd.Kernel.Tent, [1.0])
            sample_up.set_samples(i, residual.axis[i].size)
            print residual.axis[i].size,
        print
        # small but fits both char and uchar
        sample_up.set_type_out(base.type)
        current = sample_up.execute() + residual
    return current

def save_pyramid(base, residuals, name):
    desc = file(name + '.desc', 'w')
    n = name + '.base.nhdr'
    base.save(n, nrrd.NrrdIoState(format=nrrd.Format.NRRD,
                                  encoding=nrrd.Encoding.Gzip))
    desc.write(n + '\n')
    for i, residual in enumerate(residuals):
        n = name + '.r%d.nhdr' % i
        residual.save(n, nrrd.NrrdIoState(format=nrrd.Format.NRRD,
                                          encoding=nrrd.Encoding.Gzip))
        desc.write(n + '\n')

def load_pyramid(name):
    f = file(name + '.desc')
    base = nrrd.Nrrd.load(f.readline()[:-1])
    residuals = []
    l = f.readline()
    while l <> '':
        residuals.append(nrrd.Nrrd.load(l[:-1]))
        l = f.readline()
    return base, residuals
        
        
##############################################################################
