#!/usr/bin/env python

from teem import util
from teem import nrrd
import sys

def usage():
    print "%s <nrrd in> <nrrd out> <dimension_0> <dimension_1> ..." % sys.argv[0]
    print "  Resamples input nrrd using linear interpolation, saves gzipped nrrd"

def main(filename_in, filename_out, *sizes):
    isizes = list(int(i) for i in sizes)
    n = nrrd.Nrrd.load(filename_in)
    result = util.resample_single_kernel(n, nrrd.Kernel.Tent, [1.0],
                                         isizes)
    result.save(filename_out, nrrd.NrrdIoState(format=nrrd.Format.NRRD,
                                               encoding=nrrd.Encoding.Gzip))

if __name__ == '__main__':
    if len(sys.argv) < 4:
        usage()
        sys.exit(1)
    main(*sys.argv[1:])
