##############################################################################
# utility module with assorted teem utilities
# 
# Part of the python bindings for teem, by Carlos Scheidegger
# teem is developed by Gordon Kindlmann, and available at
# http://teem.sourceforge.net

from teem.nrrd import *
import os
import tempfile

def resample_single_kernel(nin, kernel, params,
                           new_sizes):
    ctx = NrrdResampleContext()
    ctx.set_nrrd(nin)
    ctx.set_default_center(Center.Node)
    for i in xrange(nin.dim):
        ctx.set_kernel(i, kernel, params)
    for i, v in enumerate(new_sizes):
        ctx.set_samples(i, v)
    ctx.set_type_out(nin.type)
    return ctx.execute()
    
def histo_show(nin):
    (fd, name) = tempfile.mkstemp('.png')
    os.close(fd)
    nin.histo(256).histoDraw(128).quantize(None, 8).save(name)
    os.system('open %s' % name)
